2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # Diagnostic for continued use of deprecated variable.
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
34 $(shell gzip
--help
2>/dev
/null|grep rsyncable
>/dev
/null \
35 && printf
%s
--rsyncable
)
36 GZIP_ENV
= '--no-name --best $(gzip_rsyncable)'
41 VC_LIST
= $(srcdir)/$(_build-aux
)/vc-list-files
-C
$(srcdir)
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?
= ^
$$
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir
= $(subst .
,\.
,$(srcdir))
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
55 _prepend_srcdir_prefix
=
57 _prepend_srcdir_prefix
= | sed
's|^|$(srcdir)/|'
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
64 $(if
$(exclude_file_name_regexp--
$@
),$(exclude_file_name_regexp--
$@
),^
$$)
66 $(VC_LIST
) | sed
's|^$(_dot_escaped_srcdir)/||' \
67 | if
test -f
$(srcdir)/.x-
$@
; then grep
-vEf
$(srcdir)/.x-
$@
; \
68 else grep
-Ev
-e
"$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69 | grep
-Ev
-e
'($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70 $(_prepend_srcdir_prefix
)
72 ifeq ($(origin prev_version_file
), undefined
)
73 prev_version_file
= $(srcdir)/.prev-version
76 PREV_VERSION
:= $(shell cat
$(prev_version_file
) 2>/dev
/null
)
77 VERSION_REGEXP
= $(subst .
,\.
,$(VERSION
))
78 PREV_VERSION_REGEXP
= $(subst .
,\.
,$(PREV_VERSION
))
81 this-vc-tag
= v
$(VERSION
)
82 this-vc-tag-regexp
= v
$(VERSION_REGEXP
)
84 tag-package
= $(shell echo
"$(PACKAGE)" | tr
'[:lower:]' '[:upper:]')
85 tag-this-version
= $(subst .
,_
,$(VERSION
))
86 this-vc-tag
= $(tag-package
)-$(tag-this-version
)
87 this-vc-tag-regexp
= $(this-vc-tag
)
89 my_distdir
= $(PACKAGE
)-$(VERSION
)
91 # Old releases are stored here.
92 release_archive_dir ?
= ..
/release
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha
= alpha.gnu.org
98 gnu_ftp_host-beta
= alpha.gnu.org
99 gnu_ftp_host-stable
= ftp.gnu.org
100 gnu_rel_host ?
= $(gnu_ftp_host-
$(RELEASE_TYPE
))
102 ifeq ($(gnu_rel_host
),ftp.gnu.org
)
103 url_dir_list ?
= http
://ftpmirror.gnu.org
/$(PACKAGE
)
105 url_dir_list ?
= ftp
://$(gnu_rel_host
)/gnu
/$(PACKAGE
)
108 # Override this in cfg.mk if you are using a different format in your
110 today
= $(shell date
+%Y-
%m-
%d
)
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec. The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?
= 1,10
117 news-check-regexp ?
= '^\*.* $(VERSION_REGEXP) \($(today)\)'
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
123 ## --------------- ##
125 ## --------------- ##
127 _cfg_mk
:= $(shell test -f
$(srcdir)/cfg.mk
&& echo
'$(srcdir)/cfg.mk')
129 # Collect the names of rules starting with 'sc_'.
130 syntax-check-rules
:= $(sort $(shell sed
-n
's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131 $(srcdir)/$(ME
) $(_cfg_mk
)))
132 .PHONY
: $(syntax-check-rules
)
134 ifeq ($(shell $(VC_LIST
) >/dev
/null
2>&1; echo
$$?
),0)
135 local-checks-available
+= $(syntax-check-rules
)
137 local-checks-available
+= no-vc-detected
139 @echo
"No version control files detected; skipping syntax check"
141 .PHONY
: $(local-checks-available
)
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules
): %: %.m
145 sc_m_rules_
= $(patsubst %, %.m
, $(syntax-check-rules
))
146 .PHONY
: $(sc_m_rules_
)
148 @echo
$(patsubst sc_
%.m
, %, $@
)
149 @date
+%s.
%N
> .sc-start-
$(basename $@
)
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_
= $(patsubst %, %.z
, $(syntax-check-rules
))
153 .PHONY
: $(sc_z_rules_
)
154 $(sc_z_rules_
): %.z
: %
155 @end
=$$(date
+%s.
%N
); \
156 start
=$$(cat .sc-start-
$*); \
157 rm -f .sc-start-
$*; \
158 awk
-v s
=$$start -v e
=$$end \
159 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev
/null
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
164 $(patsubst sc_
%, sc_
%.z
, \
165 $(filter-out $(local-checks-to-skip
), $(local-checks-available
)))
167 syntax-check
: $(local-check
)
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
174 # Parameters (shell variables):
178 # Regular expression (ERE) denoting either a forbidden construct
179 # or a required construct. Those arguments are exclusive.
181 # in_vc_files | in_files
183 # grep-E-style regexp denoting the files to check. If no files
184 # are specified the default are all the files that are under
187 # containing | non_containing
189 # Select the files (non) containing strings matching this regexp.
190 # If both arguments are specified then CONTAINING takes
195 # Extra options for grep.
203 # Message to display before to halting execution.
205 # Finally, you may exempt files based on an ERE matching file names.
206 # For example, to exempt from the sc_space_tab check all files with the
207 # .diff suffix, set this Make variable:
209 # exclude_file_name_regexp--sc_space_tab = \.diff$
211 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
212 # when filtering by name via in_files, we explicitly filter out matching
213 # names here as well.
215 # By default, _sc_search_regexp does not ignore case.
217 _ignore_case
= $$(test -n
"$$ignore_case" && printf
%s
-i ||
:)
219 define _sc_say_and_exit
220 dummy
=; : so we do not need a semicolon before each use
; \
221 { printf
'%s\n' "$(ME): $$msg" 1>&2; exit
1; };
224 define _sc_search_regexp
225 dummy
=; : so we do not need a semicolon before each use
; \
228 test -n
"$$prohibit" && test -n
"$$require" \
229 && { msg
='Cannot specify both prohibit and require' \
230 $(_sc_say_and_exit
) } ||
:; \
231 test -z
"$$prohibit" && test -z
"$$require" \
232 && { msg
='Should specify either prohibit or require' \
233 $(_sc_say_and_exit
) } ||
:; \
234 test -n
"$$in_vc_files" && test -n
"$$in_files" \
235 && { msg
='Cannot specify both in_vc_files and in_files' \
236 $(_sc_say_and_exit
) } ||
:; \
237 test "x$$halt" != x \
238 ||
{ msg
='halt not defined' $(_sc_say_and_exit
) }; \
240 : Filter by file name
; \
241 if
test -n
"$$in_files"; then \
242 files
=$$(find
$(srcdir) | grep
-E
"$$in_files" \
243 | grep
-Ev
'$(exclude_file_name_regexp--$@)'); \
245 files
=$$($(VC_LIST_EXCEPT
)); \
246 if
test -n
"$$in_vc_files"; then \
247 files
=$$(echo
"$$files" | grep
-E
"$$in_vc_files"); \
251 : Filter by content
; \
252 test -n
"$$files" && test -n
"$$containing" \
253 && { files
=$$(grep
-l
"$$containing" $$files); } ||
:; \
254 test -n
"$$files" && test -n
"$$non_containing" \
255 && { files
=$$(grep
-vl
"$$non_containing" $$files); } ||
:; \
257 : Check for the construct
; \
258 if
test -n
"$$files"; then \
259 if
test -n
"$$prohibit"; then \
260 grep
$$with_grep_options $(_ignore_case
) -nE
"$$prohibit" $$files \
261 && { msg
="$$halt" $(_sc_say_and_exit
) } ||
:; \
263 grep
$$with_grep_options $(_ignore_case
) -LE
"$$require" $$files \
265 && { msg
="$$halt" $(_sc_say_and_exit
) } ||
:; \
271 sc_avoid_if_before_free
:
272 @
$(srcdir)/$(_build-aux
)/useless-if-before-free \
273 $(useless_free_options
) \
274 $$($(VC_LIST_EXCEPT
) | grep
-v useless-if-before-free
) && \
275 { echo
'$(ME): found useless "if" before "free" above' 1>&2; \
278 sc_cast_of_argument_to_free
:
279 @prohibit
='\<free *\( *\(' halt
="don't cast free argument" \
282 sc_cast_of_x_alloc_return_value
:
283 @prohibit
='\*\) *x(m|c|re)alloc\>' \
284 halt
="don't cast x*alloc return value" \
287 sc_cast_of_alloca_return_value
:
288 @prohibit
='\*\) *alloca\>' \
289 halt
="don't cast alloca return value" \
294 halt
='found SPACE-TAB sequence; remove the SPACE' \
297 # Don't use *scanf or the old ato* functions in "real" code.
298 # They provide no error checking mechanism.
299 # Instead, use strto* functions.
300 sc_prohibit_atoi_atof
:
301 @prohibit
='\<([fs]?scanf|ato([filq]|ll)) *\(' \
302 halt
='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
305 # Use STREQ rather than comparing strcmp == 0, or != 0.
308 @grep
-nE
'! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
309 $$($(VC_LIST_EXCEPT
)) \
310 | grep
-vE
':# *define STRN?EQ\(' && \
311 { echo
'$(ME): replace strcmp calls above with STREQ/STRNEQ' \
314 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
315 # Convert all uses automatically, via these two commands:
316 # git grep -l '\<exit *(1)' \
317 # | grep -vEf .x-sc_prohibit_magic_number_exit \
318 # | xargs --no-run-if-empty \
319 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
320 # git grep -l '\<exit *(0)' \
321 # | grep -vEf .x-sc_prohibit_magic_number_exit \
322 # | xargs --no-run-if-empty \
323 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
324 sc_prohibit_magic_number_exit
:
325 @prohibit
='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
326 halt
='use EXIT_* values rather than magic number' \
329 # Using EXIT_SUCCESS as the first argument to error is misleading,
330 # since when that parameter is 0, error does not exit. Use '0' instead.
331 sc_error_exit_success
:
332 @prohibit
='error *\(EXIT_SUCCESS,' \
333 in_vc_files
='\.[chly]$$' \
334 halt
='found error (EXIT_SUCCESS' \
337 # "FATAL:" should be fully upper-cased in error messages
338 # "WARNING:" should be fully upper-cased, or fully lower-cased
339 sc_error_message_warn_fatal
:
340 @grep
-nEA2
'[^rp]error *\(' $$($(VC_LIST_EXCEPT
)) \
341 | grep
-E
'"Warning|"Fatal|"fatal' && \
342 { echo
'$(ME): use FATAL, WARNING or warning' 1>&2; \
345 # Error messages should not start with a capital letter
346 sc_error_message_uppercase
:
347 @grep
-nEA2
'[^rp]error *\(' $$($(VC_LIST_EXCEPT
)) \
349 | grep
-vE
'"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
350 { echo
'$(ME): found capitalized error message' 1>&2; \
353 # Error messages should not end with a period
354 sc_error_message_period
:
355 @grep
-nEA2
'[^rp]error *\(' $$($(VC_LIST_EXCEPT
)) \
356 | grep
-E
'[^."]\."' && \
357 { echo
'$(ME): found error message ending in period' 1>&2; \
361 @prohibit
=file
''system \
363 halt
='found use of "file''system"; spell it "file system"' \
366 # Don't use cpp tests of this symbol. All code assumes config.h is included.
367 sc_prohibit_have_config_h
:
368 @prohibit
='^# *if.*HAVE''_CONFIG_H' \
369 halt
='found use of HAVE''_CONFIG_H; remove' \
372 # Nearly all .c files must include <config.h>. However, we also permit this
373 # via inclusion of a package-specific header, if cfg.mk specified one.
374 # config_h_header must be suitable for grep -E.
375 config_h_header ?
= <config\.h
>
377 @require
='^# *include $(config_h_header)' \
378 in_vc_files
='\.c$$' \
379 halt
='the above files do not include <config.h>' \
382 # You must include <config.h> before including any other header file.
383 # This can possibly be via a package-specific header, if given by cfg.mk.
384 sc_require_config_h_first
:
385 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
387 for i in
$$($(VC_LIST_EXCEPT
) | grep
'\.c$$'); do \
388 grep
'^# *include\>' $$i | sed
1q \
389 | grep
-E
'^# *include $(config_h_header)' > /dev
/null \
390 ||
{ echo
$$i; fail
=1; }; \
393 { echo
'$(ME): the above files include some other header' \
394 'before <config.h>' 1>&2; exit
1; } ||
:; \
398 sc_prohibit_HAVE_MBRTOWC
:
399 @prohibit
='\bHAVE_MBRTOWC\b' \
400 halt
="do not use $$prohibit; it is always defined" \
403 # To use this "command" macro, you must first define two shell variables:
404 # h: the header name, with no enclosing <> or ""
405 # re: a regular expression that matches IFF something provided by $h is used.
406 define _sc_header_without_use
407 dummy
=; : so we do not need a semicolon before each use
; \
408 h_esc
=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
409 if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
410 files
=$$(grep
-l
'^# *include '"$$h_esc" \
411 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')) && \
412 grep
-LE
"$$re" $$files | grep .
&& \
413 { echo
"$(ME): the above files include $$h but don't use it" \
414 1>&2; exit
1; } ||
:; \
419 # Prohibit the inclusion of assert.h without an actual use of assert.
420 sc_prohibit_assert_without_use
:
421 @h
='assert.h' re
='\<assert *\(' $(_sc_header_without_use
)
423 # Prohibit the inclusion of close-stream.h without an actual use.
424 sc_prohibit_close_stream_without_use
:
425 @h
='close-stream.h' re
='\<close_stream *\(' $(_sc_header_without_use
)
427 # Prohibit the inclusion of getopt.h without an actual use.
428 sc_prohibit_getopt_without_use
:
429 @h
='getopt.h' re
='\<getopt(_long)? *\(' $(_sc_header_without_use
)
431 # Don't include quotearg.h unless you use one of its functions.
432 sc_prohibit_quotearg_without_use
:
433 @h
='quotearg.h' re
='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use
)
435 # Don't include quote.h unless you use one of its functions.
436 sc_prohibit_quote_without_use
:
437 @h
='quote.h' re
='\<quote(_n)? *\(' $(_sc_header_without_use
)
439 # Don't include this header unless you use one of its functions.
440 sc_prohibit_long_options_without_use
:
441 @h
='long-options.h' re
='\<parse_long_options *\(' \
442 $(_sc_header_without_use
)
444 # Don't include this header unless you use one of its functions.
445 sc_prohibit_inttostr_without_use
:
446 @h
='inttostr.h' re
='\<(off|[iu]max|uint)tostr *\(' \
447 $(_sc_header_without_use
)
449 # Don't include this header unless you use one of its functions.
450 sc_prohibit_ignore_value_without_use
:
451 @h
='ignore-value.h' re
='\<ignore_(value|ptr) *\(' \
452 $(_sc_header_without_use
)
454 # Don't include this header unless you use one of its functions.
455 sc_prohibit_error_without_use
:
457 re
='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
458 $(_sc_header_without_use
)
460 # Don't include xalloc.h unless you use one of its functions.
461 # Consider these symbols:
462 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
463 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
464 # Divide into two sets on case, and filter each through this:
465 # | sort | perl -MRegexp::Assemble -le \
466 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
467 # Note this was produced by the above:
469 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
470 # But we can do better, in at least two ways:
471 # 1) take advantage of two "dup"-suffixed strings:
472 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
473 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
475 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
476 _xa1
= x
(((2n?
)?re|char|n
(re|m
)|
[cmz
])alloc|alloc_
(oversized|die
)|
(mem|str
)dup
)
477 _xa2
= X
([CZ
]|N?M
)ALLOC
478 sc_prohibit_xalloc_without_use
:
480 re
='\<($(_xa1)|$(_xa2)) *\('\
481 $(_sc_header_without_use
)
483 # Extract function names:
484 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
486 clear|delete|free|get_
(first|next
)|insert|lookup|print_statistics|reset_tuning
487 _hash_fn
= \
<($(_hash_re
)) *\
(
488 _hash_struct
= (struct
)?\
<[Hh
]ash_
(table|tuning
)\
>
489 sc_prohibit_hash_without_use
:
491 re
='$(_hash_fn)|$(_hash_struct)'\
492 $(_sc_header_without_use
)
494 sc_prohibit_cloexec_without_use
:
495 @h
='cloexec.h' re
='\<(set_cloexec_flag|dup_cloexec) *\(' \
496 $(_sc_header_without_use
)
498 sc_prohibit_posixver_without_use
:
499 @h
='posixver.h' re
='\<posix2_version *\(' $(_sc_header_without_use
)
501 sc_prohibit_same_without_use
:
502 @h
='same.h' re
='\<same_name *\(' $(_sc_header_without_use
)
504 sc_prohibit_hash_pjw_without_use
:
507 $(_sc_header_without_use
)
509 sc_prohibit_safe_read_without_use
:
510 @h
='safe-read.h' re
='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
511 $(_sc_header_without_use
)
513 sc_prohibit_argmatch_without_use
:
515 re
='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
516 $(_sc_header_without_use
)
518 sc_prohibit_canonicalize_without_use
:
519 @h
='canonicalize.h' \
520 re
='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
521 $(_sc_header_without_use
)
523 sc_prohibit_root_dev_ino_without_use
:
524 @h
='root-dev-ino.h' \
525 re
='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
526 $(_sc_header_without_use
)
528 sc_prohibit_openat_without_use
:
530 re
='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
531 $(_sc_header_without_use
)
533 # Prohibit the inclusion of c-ctype.h without an actual use.
534 ctype_re
= isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
535 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
536 sc_prohibit_c_ctype_without_use
:
537 @h
='c-ctype.h' re
='\<c_($(ctype_re)) *\(' \
538 $(_sc_header_without_use
)
541 _sp
= $(_empty
) $(_empty
)
542 # The following list was generated by running:
543 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
544 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
546 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
547 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
548 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
549 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
550 _sig_function_re
= $(subst $(_sp
),|
,$(strip $(_sig_functions
)))
551 # The following were extracted from "man signal.h" manually.
552 _sig_types_and_consts
= \
553 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
554 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
555 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
556 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
557 sigstack sigval stack_t ucontext_t
558 # generated via this:
559 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
561 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
562 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
563 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
564 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
565 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
566 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
567 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
569 _sig_syms_re
= $(subst $(_sp
),|
,$(strip $(_sig_names
) $(_sig_types_and_consts
)))
571 # Prohibit the inclusion of signal.h without an actual use.
572 sc_prohibit_signal_without_use
:
574 re
='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
575 $(_sc_header_without_use
)
577 # Don't include stdio--.h unless you use one of its functions.
578 sc_prohibit_stdio--_without_use
:
579 @h
='stdio--.h' re
='\<((f(re)?|p)open|tmpfile) *\(' \
580 $(_sc_header_without_use
)
582 # Don't include stdio-safer.h unless you use one of its functions.
583 sc_prohibit_stdio-safer_without_use
:
584 @h
='stdio-safer.h' re
='\<((f(re)?|p)open|tmpfile)_safer *\(' \
585 $(_sc_header_without_use
)
587 # Prohibit the inclusion of strings.h without a sensible use.
588 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
589 sc_prohibit_strings_without_use
:
591 re
='\<(strn?casecmp|ffs(ll)?)\>' \
592 $(_sc_header_without_use
)
594 # Get the list of symbol names with this:
595 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
597 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
598 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
599 INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
600 INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
601 INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
602 INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
603 INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
604 INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
605 INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
606 _intprops_syms_re
= $(subst $(_sp
),|
,$(strip $(_intprops_names
)))
607 # Prohibit the inclusion of intprops.h without an actual use.
608 sc_prohibit_intprops_without_use
:
610 re
='\<($(_intprops_syms_re)) *\(' \
611 $(_sc_header_without_use
)
613 _stddef_syms_re
= NULL|offsetof|ptrdiff_t|size_t|wchar_t
614 # Prohibit the inclusion of stddef.h without an actual use.
615 sc_prohibit_stddef_without_use
:
617 re
='\<($(_stddef_syms_re))\>' \
618 $(_sc_header_without_use
)
620 _de1
= dirfd|
(close|
(fd
)?open|read|rewind|seek|tell
)dir(64)?
(_r
)?
621 _de2
= (versionsort|struct dirent|getdirentries|alphasort|scandir
(at
)?
)(64)?
622 _de3
= MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
623 _dirent_syms_re
= $(_de1
)|
$(_de2
)|
$(_de3
)
624 # Prohibit the inclusion of dirent.h without an actual use.
625 sc_prohibit_dirent_without_use
:
627 re
='\<($(_dirent_syms_re))\>' \
628 $(_sc_header_without_use
)
630 # Prohibit the inclusion of verify.h without an actual use.
631 sc_prohibit_verify_without_use
:
633 re
='\<(verify(true|expr)?|static_assert) *\(' \
634 $(_sc_header_without_use
)
636 # Don't include xfreopen.h unless you use one of its functions.
637 sc_prohibit_xfreopen_without_use
:
638 @h
='xfreopen.h' re
='\<xfreopen *\(' $(_sc_header_without_use
)
641 @prohibit
='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
642 halt
='do not use HAVE''_FCNTL_H or O'_NDELAY \
645 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
647 # Each nonempty ChangeLog line must start with a year number, or a TAB.
649 @prohibit
='^[^12 ]' \
650 in_vc_files
='^ChangeLog$$' \
651 halt
='found unexpected prefix in a ChangeLog' \
654 # Ensure that each .c file containing a "main" function also
655 # calls set_program_name.
657 @require
='set_program_name *\(m?argv\[0\]\);' \
658 in_vc_files
='\.c$$' \
659 containing
='\<main *(' \
660 halt
='the above files do not call set_program_name' \
663 # Ensure that each .c file containing a "main" function also
664 # calls bindtextdomain.
666 @require
='bindtextdomain *\(' \
667 in_vc_files
='\.c$$' \
668 containing
='\<main *(' \
669 halt
='the above files do not call bindtextdomain' \
672 # Require that the final line of each test-lib.sh-using test be this one:
674 # Note: this test requires GNU grep's --label= option.
675 Exit_witness_file ?
= tests
/test-lib.sh
676 Exit_base
:= $(notdir $(Exit_witness_file
))
677 sc_require_test_exit_idiom
:
678 @if
test -f
$(srcdir)/$(Exit_witness_file
); then \
680 for i in
$$(grep
-l
-F
'srcdir/$(Exit_base)' \
681 $$($(VC_LIST
) tests
)); do \
682 tail
-n1
$$i | grep
'^Exit .' > /dev
/null \
683 && : ||
{ die
=1; echo
$$i; } \
686 { echo
1>&2 '$(ME): the final line in each of the above is not:'; \
687 echo
1>&2 'Exit something'; \
693 halt
='found trailing blank(s)' \
696 # Match lines like the following, but where there is only one space
697 # between the options and the description:
698 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
699 longopt_re
= --[a-z
][0-9A-Za-z-
]*(\
[?
=[0-9A-Za-z-
]*\
]?
)?
700 sc_two_space_separator_in_usage
:
701 @prohibit
='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
702 halt
='help2man requires at least two spaces between an option and its description'\
705 # A regexp matching function names like "error" that may be used
706 # to emit translatable messages.
707 _gl_translatable_diag_func_re ?
= error
709 # Look for diagnostics that aren't marked for translation.
710 # This won't find any for which error's format string is on a separate line.
711 sc_unmarked_diagnostics
:
713 '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
714 $$($(VC_LIST_EXCEPT
)) \
715 | grep
-Ev
'(_|ngettext ?)\(' && \
716 { echo
'$(ME): found unmarked diagnostic(s)' 1>&2; \
719 # Avoid useless parentheses like those in this example:
720 # #if defined (SYMBOL) || defined (SYM2)
721 sc_useless_cpp_parens
:
722 @prohibit
='^# *if .*defined *\(' \
723 halt
='found useless parentheses in cpp directive' \
726 # List headers for which HAVE_HEADER_H is always true, assuming you are
727 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
728 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
729 # requires the gnulib module that guarantees the usability of that header.
730 gl_assured_headers_
= \
731 cd
$(gnulib_dir
)/lib
&& echo
*.in.h|sed
's/\.in\.h//g'
733 # Convert the list of names to upper case, and replace each space with "|".
734 az_
= abcdefghijklmnopqrstuvwxyz
735 AZ_
= ABCDEFGHIJKLMNOPQRSTUVWXYZ
736 gl_header_upper_case_or_
= \
737 $$($(gl_assured_headers_
) \
738 | tr
$(az_
)/.
- $(AZ_
)___ \
741 sc_prohibit_always_true_header_tests
:
742 @or
=$(gl_header_upper_case_or_
); \
743 re
="HAVE_($$or)_H"; \
744 prohibit
='\<'"$$re"'\>' \
745 halt
=$$(printf
'%s\n' \
746 'do not test the above HAVE_<header>_H symbol(s);' \
747 ' with the corresponding gnulib module, they are always true') \
750 # ==================================================================
751 gl_other_headers_ ?
= \
756 # Perl -lne code to extract "significant" cpp-defined symbols from a
757 # gnulib header file, eliminating a few common false-positives.
758 # The exempted names below are defined only conditionally in gnulib,
759 # and hence sometimes must/may be defined in application code.
760 gl_extract_significant_defines_
= \
761 /^\
# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
762 && $$2 !~
/(?
:rpl_|_used_without_
)/\
763 && $$1 !~
/^
(?
:NSIG|ENODATA
)$$/\
764 && $$1 !~
/^
(?
:SA_RESETHAND|SA_RESTART
)$$/\
767 # Create a list of regular expressions matching the names
768 # of macros that are guaranteed to be defined by parts of gnulib.
770 gen_h
=$(gl_generated_headers_
); \
771 (cd
$(gnulib_dir
)/lib
; \
772 for f in
*.in.h
$(gl_other_headers_
); do \
774 && perl
-lne
'$(gl_extract_significant_defines_)' $$f; \
777 | sed
's/^/^ *# *(define|undef) */;s/$$/\\>/'
780 # Don't define macros that we already get from gnulib header files.
781 sc_prohibit_always-defined_macros
:
782 @if
test -d
$(gnulib_dir
); then \
783 case
$$(echo
all: | grep
-l
-f
- Makefile
) in Makefile
);; *) \
784 echo
'$(ME): skipping $@: you lack GNU grep' 1>&2; exit
0;; \
786 $(def_sym_regex
) | grep
-E
-f
- $$($(VC_LIST_EXCEPT
)) \
787 && { echo
'$(ME): define the above via some gnulib .h file' \
788 1>&2; exit
1; } ||
:; \
790 # ==================================================================
792 # Prohibit checked in backup files.
793 sc_prohibit_backup_files
:
794 @
$(VC_LIST
) | grep
'~$$' && \
795 { echo
'$(ME): found version controlled backup file' 1>&2; \
798 # Require the latest GPL.
800 @prohibit
='either ''version [^3]' \
801 halt
='GPL vN, N!=3' \
804 # Require the latest GFDL. Two regexp, since some .texi files end up
805 # line wrapping between 'Free Documentation License,' and 'Version'.
806 _GFDL_regexp
= (Free
''Documentation.
*Version
1\.
[^
3]|Version
1\.
[^
3] or any
)
808 @prohibit
='$(_GFDL_regexp)' \
809 halt
='GFDL vN, N!=3' \
812 # Don't use Texinfo's @acronym{}.
813 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
814 texinfo_suffix_re_ ?
= \.
(txi|texi
(nfo
)?
)$$
816 @prohibit
='@acronym\{' \
817 in_vc_files
='$(texinfo_suffix_re_)' \
818 halt
='found use of Texinfo @acronym{}' \
822 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
824 sc_prohibit_cvs_keyword
:
825 @prohibit
='\$$($(cvs_keywords))\$$' \
826 halt
='do not use CVS keyword expansion' \
829 # This Perl code is slightly obfuscated. Not only is each "$" doubled
830 # because it's in a Makefile, but the $$c's are comments; we cannot
831 # use "#" due to the way the script ends up concatenated onto one line.
832 # It would be much more concise, and would produce better output (including
833 # counts) if written as:
834 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
835 # but that would be far less efficient, reading the entire contents
836 # of each file, rather than just the last two bytes of each.
837 # In addition, while the code below detects both blank lines and a missing
838 # newline at EOF, the above detects only the former.
840 # This is a perl script that is expected to be the single-quoted argument
841 # to a command-line "-le". The remaining arguments are file names.
842 # Print the name of each file that does not end in exactly one newline byte.
843 # I.e., warn if there are blank lines (2 or more newlines), or if the
844 # last byte is not a newline. However, currently we don't complain
845 # about any file that contains exactly one byte.
846 # Exit nonzero if at least one such file is found, otherwise, exit 0.
847 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
849 # Use this if you want to remove trailing empty lines from selected files:
850 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
852 require_exactly_one_NL_at_EOF_
= \
853 foreach my
$$f (@ARGV
) \
855 open F
, "<", $$f or
(warn
"failed to open $$f: $$!\n"), next
; \
856 my
$$p = sysseek
(F
, -2, 2); \
857 my
$$c = "seek failure probably means file has < 2 bytes; ignore"; \
858 my
$$last_two_bytes; \
859 defined
$$p and
$$p = sysread F
, $$last_two_bytes, 2; \
861 $$c = "ignore read failure"; \
862 $$p && ($$last_two_bytes eq
"\n\n" \
863 || substr
($$last_two_bytes,1) ne
"\n") \
864 and
(print $$f), $$fail=1; \
866 END
{ exit defined
$$fail }
867 sc_prohibit_empty_lines_at_EOF
:
868 @perl
-le
'$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT
)) \
869 ||
{ echo
'$(ME): empty line(s) or no newline at EOF' \
872 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
873 # This is a bit of a kludge, since it prevents use of the string
874 # even in comments, but for now it does the job with no false positives.
875 sc_prohibit_stat_st_blocks
:
876 @prohibit
='[.>]st_blocks' \
877 halt
='do not use st_blocks; use ST_NBLOCKS' \
880 # Make sure we don't define any S_IS* macros in src/*.c files.
881 # They're already defined via gnulib's sys/stat.h replacement.
882 sc_prohibit_S_IS_definition
:
883 @prohibit
='^ *# *define *S_IS' \
884 halt
='do not define S_IS* macros; include <sys/stat.h>' \
887 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
888 # that is shared by two definitions below.
889 perl_filename_lineno_text_
= \
891 -e
' $$n = ($$` =~ tr/\n/\n/ + 1);' \
892 -e
' ($$v = $$&) =~ s/\n/\\n/g;' \
893 -e
' print "$$ARGV:$$n:$$v\n";' \
896 prohibit_doubled_word_RE_ ?
= \
897 /\b(then?|
[iao
]n|i
[fst
]|but|f?or|at|and|
[dt
]o
)\s
+\
1\b/gims
898 prohibit_doubled_word_
= \
899 -e
'while ($(prohibit_doubled_word_RE_))' \
900 $(perl_filename_lineno_text_
)
902 # Define this to a regular expression that matches
903 # any filename:dd:match lines you want to ignore.
904 # The default is to ignore no matches.
905 ignore_doubled_word_match_RE_ ?
= ^
$$
907 sc_prohibit_doubled_word
:
908 @perl
-n
-0777 $(prohibit_doubled_word_
) $$($(VC_LIST_EXCEPT
)) \
909 | grep
-vE
'$(ignore_doubled_word_match_RE_)' \
910 | grep .
&& { echo
'$(ME): doubled words' 1>&2; exit
1; } ||
:
912 # A regular expression matching undesirable combinations of words like
913 # "can not"; this matches them even when the two words appear on different
914 # lines, but not when there is an intervening delimiter like "#" or "*".
915 prohibit_undesirable_word_seq_RE_ ?
= \
917 prohibit_undesirable_word_seq_
= \
918 -e
'while ($(prohibit_undesirable_word_seq_RE_))' \
919 $(perl_filename_lineno_text_
)
920 # Define this to a regular expression that matches
921 # any filename:dd:match lines you want to ignore.
922 # The default is to ignore no matches.
923 ignore_undesirable_word_sequence_RE_ ?
= ^
$$
925 sc_prohibit_undesirable_word_seq
:
926 @perl
-n
-0777 $(prohibit_undesirable_word_seq_
) \
927 $$($(VC_LIST_EXCEPT
)) \
928 | grep
-vE
'$(ignore_undesirable_word_sequence_RE_)' | grep . \
929 && { echo
'$(ME): undesirable word sequence' >&2; exit
1; } ||
:
931 _ptm1
= use
"test C1 && test C2", not
"test C1 -''a C2"
932 _ptm2
= use
"test C1 || test C2", not
"test C1 -''o C2"
933 # Using test's -a and -o operators is not portable.
934 # We prefer test over [, since the latter is spelled [[ in configure.ac.
935 sc_prohibit_test_minus_ao
:
936 @prohibit
='(\<test| \[+) .+ -[ao] ' \
937 halt
='$(_ptm1); $(_ptm2)' \
940 # Avoid a test bashism.
941 sc_prohibit_test_double_equal
:
942 @prohibit
='(\<test| \[+) .+ == ' \
943 containing
='#! */bin/[a-z]*sh' \
944 halt
='use "test x = x", not "test x =''= x"' \
947 # Each program that uses proper_name_utf8 must link with one of the
948 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
949 # The perl -0777 invocation below extracts the possibly-multi-line
950 # definition of LDADD from the appropriate Makefile.am and exits 0
951 # when it contains "ICONV".
952 sc_proper_name_utf8_requires_ICONV
:
953 @progs
=$$(grep
-l
'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT
)));\
954 if
test "x$$progs" != x
; then \
956 for p in
$$progs; do \
957 dir=$$(dirname
"$$p"); \
959 -ne
'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
960 $$dir/Makefile.am
&& continue
; \
961 base
=$$(basename "$$p" .c
); \
962 grep
"$${base}_LDADD.*ICONV)" $$dir/Makefile.am
> /dev
/null \
963 ||
{ fail
=1; echo
1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
966 { echo
1>&2 '$(ME): the above do not link with any ICONV library'; \
970 # Warn about "c0nst struct Foo const foo[]",
971 # but not about "char const *const foo" or "#define const const".
973 @prohibit
='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
974 halt
='redundant "const" in declarations' \
977 sc_const_long_option
:
978 @grep
'^ *static.*struct option ' $$($(VC_LIST_EXCEPT
)) \
979 | grep
-Ev
'const struct option|struct option const' && { \
980 echo
1>&2 '$(ME): add "const" to the above declarations'; \
984 $$(sed
-n
'/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
987 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
991 # Ensure that we don't accidentally insert an entry into an old NEWS block.
993 @if
test -f
$(srcdir)/NEWS
; then \
994 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
995 { echo
'$(ME): you have modified old NEWS' 1>&2; exit
1; }; \
998 # Update the hash stored above. Do this after each release and
999 # for any corrections to old entries.
1000 update-NEWS-hash
: NEWS
1001 perl
-pi
-e
's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1004 # Ensure that we use only the standard $(VAR) notation,
1005 # not @...@ in Makefile.am, now that we can rely on automake
1006 # to emit a definition for each substituted variable.
1007 # However, there is still one case in which @VAR@ use is not just
1008 # legitimate, but actually required: when augmenting an automake-defined
1009 # variable with a prefix. For example, gettext uses this:
1010 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1011 # otherwise, makeinfo would put German or French (current locale)
1012 # navigation hints in the otherwise-English documentation.
1014 # Allow the package to add exceptions via a hook in cfg.mk;
1015 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1016 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1017 _makefile_at_at_check_exceptions ?
=
1018 sc_makefile_at_at_check
:
1019 @perl
-ne
'/\@\w+\@/' \
1020 -e
' && !/(\w+)\s+=.*\@\1\@$$/' \
1021 -e
''$(_makefile_at_at_check_exceptions
) \
1022 -e
'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1023 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1024 && { echo
'$(ME): use $$(...), not @...@' 1>&2; exit
1; } ||
:
1027 if sed
-n
$(news-check-lines-spec
)p
$(srcdir)/NEWS \
1028 | grep
-E
$(news-check-regexp
) >/dev
/null
; then \
1031 echo
'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1035 sc_makefile_TAB_only_indentation
:
1036 @prohibit
='^ [ ]{8}' \
1037 in_vc_files
='akefile|\.mk$$' \
1038 halt
='found TAB-8-space indentation' \
1039 $(_sc_search_regexp
)
1042 @prohibit
='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1043 in_vc_files
='(^configure\.ac|\.m4)$$' \
1044 halt
='quote the first arg to AC_DEF*' \
1045 $(_sc_search_regexp
)
1047 fix_po_file_diag
= \
1048 'you have changed the set of files with translatable diagnostics;\n\
1049 apply the above patch\n'
1051 # Verify that all source files using _() are listed in po/POTFILES.in.
1052 po_file ?
= $(srcdir)/po
/POTFILES.in
1053 generated_files ?
= $(srcdir)/lib
/*.
[ch
]
1055 @if
test -f
$(po_file
); then \
1056 grep
-E
-v
'^(#|$$)' $(po_file
) \
1057 | grep
-v
'^src/false\.c$$' |
sort > $@
-1; \
1059 for file in
$$($(VC_LIST_EXCEPT
)) $(generated_files
); do \
1060 test -r
$$file || continue
; \
1062 *.m4|
*.mk
) continue
;; \
1068 base
=`expr " $$file" : ' \(.*\)\..'`; \
1069 { test -f
$$base.l ||
test -f
$$base.y
; } && continue
;; \
1071 files
="$$files $$file"; \
1073 grep
-E
-l
'\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
1074 | sed
's|^$(_dot_escaped_srcdir)/||' |
sort -u
> $@
-2; \
1075 diff
-u
-L
$(po_file
) -L
$(po_file
) $@
-1 $@
-2 \
1076 ||
{ printf
'$(ME): '$(fix_po_file_diag
) 1>&2; exit
1; }; \
1080 # Sometimes it is useful to change the PATH environment variable
1081 # in Makefiles. When doing so, it's better not to use the Unix-centric
1082 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1083 msg
= '$(ME): Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1084 sc_makefile_path_separator_check
:
1085 @prohibit
='PATH[=].*:' \
1086 in_vc_files
='akefile|\.mk$$' \
1088 $(_sc_search_regexp
)
1090 # Check that 'make alpha' will not fail at the end of the process,
1091 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1094 if
test -d
$(release_archive_dir
); then \
1095 for file in
$(DIST_ARCHIVES
); do \
1096 for p in .
/ $(release_archive_dir
)/; do \
1097 test -e
$$p$$file || continue
; \
1099 ||
{ echo ERROR
: $$p$$file is not writable
; fail
=1; }; \
1102 test "$$fail" && exit
1 ||
: ; \
1106 v_etc_file
= $(gnulib_dir
)/lib
/version-etc.c
1107 sample-test
= tests
/sample-test
1108 texi
= doc
/$(PACKAGE
).texi
1109 # Make sure that the copyright date in $(v_etc_file) is up to date.
1110 # Do the same for the $(sample-test) and the main doc/.texi file.
1112 @require
='enum { COPYRIGHT_YEAR = '$$(date
+%Y
)' };' \
1113 in_files
=$(v_etc_file
) \
1114 halt
='out of date copyright in $(v_etc_file); update it' \
1115 $(_sc_search_regexp
)
1116 @require
='# Copyright \(C\) '$$(date
+%Y
)' Free' \
1117 in_vc_files
=$(sample-test
) \
1118 halt
='out of date copyright in $(sample-test); update it' \
1119 $(_sc_search_regexp
)
1120 @require
='Copyright @copyright\{\} .*'$$(date
+%Y
)' Free' \
1121 in_vc_files
=$(texi
) \
1122 halt
='out of date copyright in $(texi); update it' \
1123 $(_sc_search_regexp
)
1125 # If tests/help-version exists and seems to be new enough, assume that its
1126 # use of init.sh and path_prepend_ is correct, and ensure that every other
1127 # use of init.sh is identical.
1128 # This is useful because help-version cross-checks prog --version
1129 # with $(VERSION), which verifies that its path_prepend_ invocation
1130 # sets PATH correctly. This is an inexpensive way to ensure that
1131 # the other init.sh-using tests also get it right.
1132 _hv_file ?
= $(srcdir)/tests
/help-version
1133 _hv_regex_weak ?
= ^
*\. .
*/init\.sh
"
1134 # Fix syntax-highlighters "
1135 _hv_regex_strong ?
= ^
*\.
"\$${srcdir=\.}/init\.sh"
1136 sc_cross_check_PATH_usage_in_tests
:
1137 @if
test -f
$(_hv_file
); then \
1138 grep
-l
'VERSION mismatch' $(_hv_file
) >/dev
/null \
1139 ||
{ echo
"$@: skipped: no such file: $(_hv_file)" 1>&2; \
1141 grep
-lE
'$(_hv_regex_strong)' $(_hv_file
) >/dev
/null \
1142 ||
{ echo
"$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1144 good
=$$(grep
-E
'$(_hv_regex_strong)' $(_hv_file
)); \
1145 grep
-LFx
"$$good" \
1146 $$(grep
-lE
'$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT
))) \
1148 { echo
"$(ME): the above files use path_prepend_ inconsistently" \
1149 1>&2; exit
1; } ||
:; \
1152 # BRE regex of file contents to identify a test script.
1153 _test_script_regex ?
= \
<init\.sh\
>
1155 # In tests, use "compare expected actual", not the reverse.
1156 sc_prohibit_reversed_compare_failure
:
1157 @prohibit
='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1158 containing
='$(_test_script_regex)' \
1159 halt
='reversed compare arguments' \
1160 $(_sc_search_regexp
)
1162 # #if HAVE_... will evaluate to false for any non numeric string.
1163 # That would be flagged by using -Wundef, however gnulib currently
1164 # tests many undefined macros, and so we can't enable that option.
1165 # So at least preclude common boolean strings as macro values.
1167 @prohibit
='^#define.*(yes|no|true|false)$$' \
1168 in_files
='$(CONFIG_INCLUDE)' \
1169 halt
='Use 0 or 1 for macro values' \
1170 $(_sc_search_regexp
)
1172 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1173 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1174 # a limit, not an array or alloca size.
1175 sc_prohibit_path_max_allocation
:
1176 @prohibit
='(\balloca *\([^)]*|\[[^]]*)PATH_MAX' \
1177 halt
='Avoid stack allocations of size PATH_MAX' \
1178 $(_sc_search_regexp
)
1180 sc_vulnerable_makefile_CVE-2009-4029
:
1181 @prohibit
='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1182 in_files
=$$(find
$(srcdir) -name Makefile.in
) \
1183 halt
=$$(printf
'%s\n' \
1184 'the above files are vulnerable; beware of running' \
1185 ' "make dist*" rules, and upgrade to fixed automake' \
1186 ' see http://bugzilla.redhat.com/542609 for details') \
1187 $(_sc_search_regexp
)
1190 (unset CDPATH
; cd
$(srcdir) && $(VC
) diff
) > vc-diffs ||
:
1191 if
test -s vc-diffs
; then \
1193 echo
"Some files are locally modified:" 1>&2; \
1199 rel-files
= $(DIST_ARCHIVES
)
1201 gnulib_dir ?
= $(srcdir)/gnulib
1202 gnulib-version
= $$(cd
$(gnulib_dir
) && git describe
)
1203 bootstrap-tools ?
= autoconf
,automake
,gnulib
1205 # If it's not already specified, derive the GPG key ID from
1206 # the signed tag we've just applied to mark this release.
1208 $$(git cat-file tag v
$(VERSION
) \
1209 | gpgv
--status-fd
1 --keyring
/dev
/null
- - 2>/dev
/null \
1210 | sed
-n
'/^\[GNUPG:\] ERRSIG /{s///;s/ .*//p;q}')
1212 translation_project_ ?
= coordinator@translationproject.org
1214 # Make info-gnu the default only for a stable release.
1215 ifeq ($(RELEASE_TYPE
),stable
)
1216 announcement_Cc_ ?
= $(translation_project_
), $(PACKAGE_BUGREPORT
)
1217 announcement_mail_headers_ ?
= \
1218 To
: info-gnu@gnu.org \
1219 Cc
: $(announcement_Cc_
) \
1220 Mail-Followup-To
: $(PACKAGE_BUGREPORT
)
1222 announcement_Cc_ ?
= $(translation_project_
)
1223 announcement_mail_headers_ ?
= \
1224 To
: $(PACKAGE_BUGREPORT
) \
1225 Cc
: $(announcement_Cc_
)
1228 announcement
: NEWS ChangeLog
$(rel-files
)
1229 @
$(srcdir)/$(_build-aux
)/announce-gen \
1230 --mail-headers
='$(announcement_mail_headers_)' \
1231 --release-type
=$(RELEASE_TYPE
) \
1232 --package
=$(PACKAGE
) \
1233 --prev
=$(PREV_VERSION
) \
1235 --gpg-key-id
=$(gpg_key_ID
) \
1236 --news
=$(srcdir)/NEWS \
1237 --bootstrap-tools
=$(bootstrap-tools
) \
1238 --gnulib-version
=$(gnulib-version
) \
1239 --no-print-checksums \
1240 $(addprefix --url-dir
=, $(url_dir_list
))
1242 ## ---------------- ##
1243 ## Updating files. ##
1244 ## ---------------- ##
1246 ftp-gnu
= ftp
://ftp.gnu.org
/gnu
1247 www-gnu
= http
://www.gnu.org
1249 upload_dest_dir_ ?
= $(PACKAGE
)
1250 emit_upload_commands
:
1251 @echo
=====================================
1252 @echo
=====================================
1253 @echo
"$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1254 @echo
" --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1255 @echo
" $(rel-files)"
1256 @echo
'# send the ~/announce-$(my_distdir) e-mail'
1257 @echo
=====================================
1258 @echo
=====================================
1260 define emit-commit-log
1261 printf
'%s\n' 'maint: post-release administrivia' '' \
1262 '* NEWS: Add header line for next release.' \
1263 '* .prev-version: Record previous version.' \
1264 '* cfg.mk (old_NEWS_hash): Auto-update.'
1267 .PHONY
: no-submodule-changes
1268 no-submodule-changes
:
1269 if
test -d
$(srcdir)/.git
; then \
1270 diff
=$$(cd
$(srcdir) && git submodule
-q
foreach \
1271 git diff-index
--name-only HEAD
) \
1273 case
$$diff in
'') ;; \
1274 *) echo
'$(ME): submodule files are locally modified:'; \
1275 echo
"$$diff"; exit
1;; esac
; \
1280 submodule-checks ?
= no-submodule-changes public-submodule-commit
1282 # Ensure that each sub-module commit we're using is public.
1283 # Without this, it is too easy to tag and release code that
1284 # cannot be built from a fresh clone.
1285 .PHONY
: public-submodule-commit
1286 public-submodule-commit
:
1287 $(AM_V_GEN
)if
test -d
$(srcdir)/.git
; then \
1289 git submodule
--quiet
foreach test '$$(git rev-parse $$sha1)' \
1290 = '$$(git merge-base origin $$sha1)' \
1291 ||
{ echo
'$(ME): found non-public submodule commit' >&2; \
1296 # This rule has a high enough utility/cost ratio that it should be a
1297 # dependent of "check" by default. However, some of us do occasionally
1298 # commit a temporary change that deliberately points to a non-public
1299 # submodule commit, and want to be able to use rules like "make check".
1300 # In that case, run e.g., "make check gl_public_submodule_commit="
1301 # to disable this test.
1302 gl_public_submodule_commit ?
= public-submodule-commit
1303 check: $(gl_public_submodule_commit
)
1305 .PHONY
: alpha beta stable
1306 ALL_RECURSIVE_TARGETS
+= alpha beta stable
1307 alpha beta stable
: $(local-check
) writable-files
$(submodule-checks
)
1309 && { echo
$(VERSION
) | grep
-E
'^[0-9]+(\.[0-9]+)+$$' \
1310 ||
{ echo
"invalid version string: $(VERSION)" 1>&2; exit
1;};}\
1312 $(MAKE
) vc-diff-check
1315 $(MAKE
) dist XZ_OPT
=-9ev
1316 $(MAKE
) $(release-prep-hook
) RELEASE_TYPE
=$@
1317 $(MAKE
) -s emit_upload_commands RELEASE_TYPE
=$@
1319 # Override this in cfg.mk if you follow different procedures.
1320 release-prep-hook ?
= release-prep
1322 gl_noteworthy_news_
= * Noteworthy changes in release ?.?
(????
-??
-??
) [?
]
1323 .PHONY
: release-prep
1325 case
$$RELEASE_TYPE in alpha|beta|stable
) ;; \
1326 *) echo
"invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit
1;; esac
1327 $(MAKE
) --no-print-directory
-s announcement
> ~
/announce-
$(my_distdir
)
1328 if
test -d
$(release_archive_dir
); then \
1329 ln
$(rel-files
) $(release_archive_dir
); \
1330 chmod a-w
$(rel-files
); \
1332 echo
$(VERSION
) > $(prev_version_file
)
1333 $(MAKE
) update-NEWS-hash
1334 perl
-pi
-e
'$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1335 $(emit-commit-log
) > .ci-msg
1336 $(VC
) commit
-F .ci-msg
-a
1339 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1340 # if the default $(PACKAGE)-derived name doesn't apply.
1345 @
test -z
"$(manual_title)" \
1346 && { echo
define manual_title in cfg.mk
1>&2; exit
1; } ||
:
1347 @cd
'$(srcdir)/doc'; \
1348 $(SHELL
) ..
/$(_build-aux
)/gendocs.sh
$(gendocs_options_
) \
1349 -o
'$(abs_builddir)/doc/manual' \
1350 --email
$(PACKAGE_BUGREPORT
) $(PACKAGE
) \
1351 "$(PACKAGE_NAME) - $(manual_title)"
1352 @echo
" *** Upload the doc/manual directory to web-cvs."
1357 $(MAKE
) $(AM_MAKEFLAGS
) clean
1358 lcov
--directory .
--zerocounters
1360 COVERAGE_CCOPTS ?
= "-g --coverage"
1361 COVERAGE_OUT ?
= doc
/coverage
1364 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
)
1365 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
) check
1366 mkdir
-p
$(COVERAGE_OUT
)
1367 lcov
--directory .
--output-file
$(COVERAGE_OUT
)/$(PACKAGE
).
info \
1371 genhtml
--output-directory
$(COVERAGE_OUT
) \
1372 $(COVERAGE_OUT
)/$(PACKAGE
).
info \
1373 --highlight
--frames
--legend \
1374 --title
"$(PACKAGE_NAME)"
1376 coverage
: init-coverage build-coverage gen-coverage
1378 # Update gettext files.
1379 PACKAGE ?
= $(shell basename $(PWD
))
1380 PO_DOMAIN ?
= $(PACKAGE
)
1381 POURL
= http
://translationproject.org
/latest
/$(PO_DOMAIN
)/
1384 rm -f
$(PODIR
)/*.po
&& \
1385 echo
"$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1386 wget
--no-verbose
--directory-prefix
$(PODIR
) --no-directories
--recursive
--level
1 --accept .po
--accept .po
.1 $(POURL
) && \
1387 echo
'en@boldquot' > $(PODIR
)/LINGUAS
&& \
1388 echo
'en@quot' >> $(PODIR
)/LINGUAS
&& \
1389 ls
$(PODIR
)/*.po | sed
's/\.po//' | sed
's,$(PODIR)/,,' |
sort >> $(PODIR
)/LINGUAS
1391 # Running indent once is not idempotent, but running it twice is.
1392 INDENT_SOURCES ?
= $(C_SOURCES
)
1395 indent
$(INDENT_SOURCES
)
1396 indent
$(INDENT_SOURCES
)
1398 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1399 # put the assignments in this variable.
1400 update-copyright-env ?
=
1402 # Run this rule once per year (usually early in January)
1403 # to update all FSF copyright year lists in your project.
1404 # If you have an additional project-specific rule,
1405 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1406 # By default, exclude all variants of COPYING; you can also
1407 # add exemptions (such as ChangeLog..* for rotated change logs)
1408 # in the file .x-update-copyright.
1409 .PHONY
: update-copyright
1411 grep
-l
-w Copyright \
1412 $$(export VC_LIST_EXCEPT_DEFAULT
=COPYING
&& $(VC_LIST_EXCEPT
)) \
1413 |
$(update-copyright-env
) xargs
$(srcdir)/$(_build-aux
)/$@
1415 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1416 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1418 # NOTE: to override any _gl_TS_* default value, you must
1419 # define the variable(s) using "export" in cfg.mk.
1422 ALL_RECURSIVE_TARGETS
+= sc_tight_scope
1423 sc_tight_scope
: tight-scope.mk
1425 if
! grep
'^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1427 && ! grep
-w noinst_HEADERS
$(srcdir)/$(_gl_TS_dir
)/Makefile.am \
1428 > /dev
/null
2>&1; then \
1429 echo
'$(ME): skipping $@'; \
1431 $(MAKE
) -s
-C
$(_gl_TS_dir
) \
1433 -f
$(abs_top_srcdir
)/cfg.mk \
1434 -f
$(abs_top_builddir
)/$< \
1441 tight-scope.mk
: $(ME
)
1443 @perl
-ne
'/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME
) > $@
-t
1444 @chmod a
=r
$@
-t
&& mv
$@
-t
$@
1449 # Most functions should have static scope.
1450 # Any that don't must be marked with 'extern', but 'main'
1451 # and 'usage' are exceptions: they're always extern, but
1452 # do not need to be marked. Symbols matching '__.*' are
1453 # reserved by the compiler, so are automatically excluded below.
1454 _gl_TS_unmarked_extern_functions ?
= main usage
1455 _gl_TS_function_match ?
= /^
(?
:$(_gl_TS_extern
)) +.
*?
(\S
+) *\
(/
1457 # If your project uses a macro like "XTERN", then put
1458 # the following in cfg.mk to override this default:
1459 # export _gl_TS_extern = extern|XTERN
1460 _gl_TS_extern ?
= extern
1462 # The second nm|grep checks for file-scope variables with 'extern' scope.
1463 # Without gnulib's progname module, you might put program_name here.
1464 # Symbols matching '__.*' are reserved by the compiler,
1465 # so are automatically excluded below.
1466 _gl_TS_unmarked_extern_vars ?
=
1468 # NOTE: the _match variables are perl expressions -- not mere regular
1469 # expressions -- so that you can extend them to match other patterns
1470 # and easily extract matched variable names.
1471 # For example, if your project declares some global variables via
1472 # a macro like this: GLOBAL(type, var_name, initializer), then you
1473 # can override this definition to automatically extract those names:
1474 # export _gl_TS_var_match = \
1475 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1476 _gl_TS_var_match ?
= /^
(?
:$(_gl_TS_extern
)) .
*?
(\w
+)(\
[.
*?\
])?
;/
1478 # The names of object files in (or relative to) $(_gl_TS_dir).
1479 _gl_TS_obj_files ?
= *.
$(OBJEXT
)
1481 # Files in which to search for the one-line style extern declarations.
1482 # $(_gl_TS_dir)-relative.
1483 _gl_TS_headers ?
= $(noinst_HEADERS
)
1485 .PHONY
: _gl_tight_scope
1486 _gl_tight_scope
: $(bin_PROGRAMS
)
1487 t
=exceptions-
$$$$; \
1488 trap
's=$$?; rm -f $$t; exit $$s' 0; \
1489 for sig in
1 2 3 13 15; do \
1490 eval
"trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1492 src
=`for f in $(SOURCES); do \
1493 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1494 hdr
=`for f in $(_gl_TS_headers); do \
1495 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1496 ( printf
'^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions
); \
1497 grep
-h
-A1
'^extern .*[^;]$$' $$src \
1498 | grep
-vE
'^(extern |--)' | sed
's/ .*//'; \
1500 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1501 ) |
sort -u
> $$t; \
1502 nm
-e
$(_gl_TS_obj_files
) | sed
-n
's/.* T //p'|grep
-Ev
-f
$$t \
1503 && { echo the above functions should have static scope
>&2; \
1505 ( printf
'^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars
); \
1506 perl
-lne
'$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1507 ) |
sort -u
> $$t; \
1508 nm
-e
$(_gl_TS_obj_files
) | sed
-n
's/.* [BCDGRS] //p' \
1509 |
sort -u | grep
-Ev
-f
$$t \
1510 && { echo the above variables should have static scope
>&2; \